# SourcePath: libpng/20140606dev
Summary: PNG library
Name: sony-target-dev-libpng
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-libpng
Version: 1.6.1
Release: 11000101
Source: libpng-%{version}.tar.bz2
Source10: sony-libpng-libopt-build-libpng
Patch1: libpng-remove-oldso.patch
Patch2: libpng-cross.patch
Patch3: libpng-fpic.patch
Patch4: libpng-so.patch
Patch5: libpng-neon-changes.patch
Patch6: CVE-2013-6954.patch
Patch7: CVE-2014-0333.patch
URL: http://www.libpng.org/pub/png/libpng.html
License: Zlib License
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
Buildroot: %{_tmppath}/%{name}-root
%define targetroot %{sony_target_dir}
Prefix: %{sony_target_dir}
BuildRequires: %{sony_tool_triplet}-%{sony_target_dialect}-dev-zlib


%define _bindir         %{sony_target_dir}%{sony_target_dev_bin_dir}
%define _incdir         %{sony_target_dir}%{sony_target_dev_include_dir}
%define _libdir         %{sony_target_dir}%{sony_target_dev_lib_dir}
%define _mandir         %{sony_target_dir}%{sony_target_dev_man_dir}
%define _infodir        %{sony_target_dir}%{sony_target_dev_info_dir}
# %define _datadir        %{sony_target_dir}%{_hhl_target_sharedstate_dir}
%define _docdir         %{sony_target_dir}%{sony_target_dev_doc_dir}

%define MAJOR   `echo %{version} | ( IFS=".$IFS" ; read x y z && echo $x$y)`
%define MINOR   `echo %{version} | cut -d'.' -f3`

%description
libpng is a library implementing an interface for reading and writing
PNG (Portable Network Graphics) format files.

%package -n %{pkgname}
Summary: PNG library
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
libpng is a library implementing an interface for reading and writing
PNG (Portable Network Graphics) format files.

%prep
%setup -n libpng-%{version} -q

cp scripts/makefile.linux makefile

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p0

%build
%sony_target_dev_setup
# NOTE: can't use target_configure function because this
# software has no configure script whatsoever.

touch .depend

make ZLIBLIB=%{sony_target_dir}%{sony_target_dev_lib_dir} ZLIBINC=%{sony_target_dir}%{sony_target_dev_include_dir} CFLAGS="-g -O2 -D__ARM_NEON__" ASFLAGS="-D__ARM_NEON__" prefix=%{sony_target_dev_prefix}


%install
rm -rf ${RPM_BUILD_ROOT}
%sony_target_dev_setup

make install prefix=${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_prefix}/ INCPATH=${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_include_dir}

# create symbolic link for libpng.so.XX
cd  ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_lib_dir}
ln -s libpng.so.%{MAJOR}.%{MINOR} libpng.so.%{MAJOR}
cd -

# Begin for LOT

mkdir -p ${RPM_BUILD_ROOT}%{sony_target_dir}/lib
mkdir -p ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libpng

# Set Library Optimizer variables
%define _optdir ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo
%define _rootlibdir ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_lib_dir}

# Install Library Optimizer information (libpng)
install -m 755 %{SOURCE10} %{_optdir}/libpng/build
install -m 644 arm/*.o *.pic.o %{_optdir}/libpng/
(cd %{_optdir}/libpng; umask 022; %{sony_cross_bin_dir}/%{sony_tool_triplet}-libindex %{_rootlibdir}/libpng.so -o *.pic.o > index)
(umask 022; echo "/usr/lib/libpng.so.%{MAJOR}" > %{_optdir}/libpng/path)

%demangle_libtool

rm -rf ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_man_dir}

# 6.x
mkdir -p ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_devtool_bin_dir}
mv ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_bin_dir}/*-config \
	${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_devtool_bin_dir}
rm -rf ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_bin_dir}

mkdir -p ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_devtool_lib_dir}
mv ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_lib_dir}/*.a \
	${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_devtool_lib_dir}
mv ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_lib_dir}/pkgconfig \
	${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_devtool_lib_dir}

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`; do
    if [ "$l" != "pkgconfig" -a "$l" != "optinfo" ]; then
    	ln -s ../..%{sony_target_devtool_lib_dir}/$l \
	    ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
    fi
done


%clean
rm -rf ${RPM_BUILD_ROOT}


%files -n %{pkgname}
%defattr(-,root,root)
%{_libdir}/libpng.so*
%{_incdir}/png.h
%{_incdir}/pngconf.h
%{_incdir}/pnglibconf.h
%{_incdir}/pngstruct.h
%{_incdir}/pnginfo.h
%{_libdir}/libpng.a
%{sony_target_dir}%{sony_target_devtool_bin_dir}/libpng-config
%{sony_target_dir}%{sony_target_devtool_lib_dir}/pkgconfig/libpng.pc

# for LOT
%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/*

%{sony_target_dir}%{sony_target_devtool_lib_dir}/libpng.a

%changelog
* Fri Jun 06 2014 Sony Corporation
- Added CVE-2013-6954 and CVE-2014-0333 fix patches
- Changed Release version to 11000101

* Mon Aug 12 2013 Sony Corporation
- Changed License information.

* Fri May 03 2013 Sony Corporation
- Added NEON support

* Mon Apr 15 2013 Sony Corporation
- version-up 1.4.9 -> 1.6.1

* Tue Mar 06 2012 Sony Corporation
- version-up 1.4.8 -> 1.4.9

* Tue Feb 28 2012 Sony Corporation
- Added LOT support

* Thu Sep 15 2011 Sony Corporation
- version-up 1.4.5 -> 1.4.8

* Mon Mar 28 2011 Sony Corporation
- Created symbolic link for libpng.so.14

* Tue Feb 22 2011 Sony Corporation
- version-up 1.2.37 -> 1.4.5

* Thu Sep 16 2010 Sony Corporation
- Add CVE-2010-1205 security fix patch
- Add CVE-2010-2249 security fix patch

* Tue May 18 2010 Sony Corporation
- Add CVE-2010-0205 security fix patch

* Thu Jul 02 2009 Sony Corporation
- version-up 1.2.35 -> 1.2.37

* Tue Mar 03 2009 Sony Corporation
- version-up 1.2.29 -> 1.2.35

* Tue Jun 10 2008 Sony Corporation
- use scripts/makefile.linux for creating libpng-config and libpng.pc

* Mon Jun 09 2008 Sony Corporation
- version-up 1.2.28 -> 1.2.29

* Thu May 08 2008 Sony Corporation
- version-up 1.2.26 -> 1.2.28

* Mon Apr 28 2008 Sony Corporation
- version-up 1.2.22 -> 1.2.26

* Tue Oct 30 2007 Sony Corporation
- version-up 1.2.18 -> 1.2.22

* Tue May 22 2007 Sony Corporation
- Version update to 1.2.18

* Wed Mar 07 2007 Sony Corporation
- Version update to 1.2.16

* Fri Jun 16 2006 Sony Corporation
- Add -fpic option patch
- Release No 1up (020001->020101)

* Tue Apr 04 2006 Sony Corporation
- update libpng version 1.2.8

* Wed Jul  6 2005 Sony Corporation - 1.2.6-2
- Change .so version.
- Add IDAT datastream bugfix patch.

* Fri Jul 01 2005 Sony Corporation - dev-libpng
- Initial build.
